#include    <stdio.h>
#include    <stdlib.h>
#include    <unistd.h>
#include    <time.h>
#include    <gx.h>

#define     VIEW_WIDTH      400         //  ϱ   ,  Կ  ߰
#define     VIEW_HEIGHT     300         //  ϱ   ,  Կ  ߰
#define     HALF_WIDTH      200         //  ϱ    
#define     HALF_HEIGHT     150         //  ϱ    
#define     CENTER_X        HALF_WIDTH  //  ϱ   ߽ ǥ,  Կ  ߰
#define     CENTER_Y        HALF_HEIGHT //  ϱ   ߽ ǥ,  Կ  ߰

dc_t   *dc_screen;                      // ȭ Device Context

void test_bitblt_mask( void)
{
    dc_t       *dc_fore;                                                        //   ̹
    dc_t       *dc_back;                                                        //  õǾ   ̹
    dc_t       *dc_mask;                                                        // mask ̹
    
    color_t     color;

    dc_fore = gx_get_compatible_dc( dc_screen);
    dc_back = gx_get_compatible_dc( dc_screen);
    dc_mask = gx_get_compatible_dc( dc_screen);

    gx_open_file( dc_fore, "gx_bitblt_mask_fore.bmp");
    gx_open_file( dc_back, "gx_bitblt_mask_back.bmp");
    gx_open_file( dc_mask, "gx_bitblt_mask_mask.bmp");
    
    gx_bitblt( dc_screen, 0, 0, dc_fore, 0, 0, dc_screen->width, dc_screen->height);
    getchar();

    gx_get_pixel( dc_mask, 200, 300, &color);

    gx_bitblt_mask( dc_screen, dc_back, dc_mask, color, 24, 45, 530, 414);
    getchar();
    gx_bitblt_mask( dc_screen, dc_fore, dc_mask, color, 24, 45, 530, 414);
    getchar();

    gx_get_pixel( dc_mask, 365, 165, &color);

    gx_bitblt_mask( dc_screen, dc_back, dc_mask, color, 333, 133, 82, 89);
    getchar();
    gx_bitblt_mask( dc_screen, dc_fore, dc_mask, color, 333, 133, 82, 89);
    
    gx_release_dc( dc_back);
    gx_release_dc( dc_mask);
    gx_release_dc( dc_fore);
}

void test_file_open( void)
{
    dc_t       *dc_comp;                                                        //   ̹
    
    dc_comp = gx_get_compatible_dc( dc_screen);

    gx_open_file( dc_comp, "bpp-32.bmp");
    gx_bitblt( dc_screen, 0, 0, dc_comp, 0, 0, dc_screen->width, dc_screen->height);
    getchar();

    gx_open_file( dc_comp, "jpeg-image.jpg");
    gx_bitblt( dc_screen, 0, 0, dc_comp, 0, 0, dc_screen->width, dc_screen->height);
    getchar();

    gx_open_file( dc_comp, "png-24bpp.png");
    gx_bitblt( dc_screen, 0, 0, dc_comp, 0, 0, dc_screen->width, dc_screen->height);
    getchar();

    gx_release_dc( dc_comp);
}

void test_layer( void)
{
    png_t      *png;                    // PNG ̹ εϱ  
    bmp_t      *bmp;                    // BmP ̹ εϱ  
    layer_t    *layer;                  // ̾ ü
    int         ndx_fish;               //  ׸ ̾ ε ȣ
    int         ndx_chimpanzee;         // ħ ׸ ̾ ε ȣ
    int         ndx_lft_button;         //  ư   ̾ ε  ȣ
    int         ndx_lft_clicked;        //  ư   ̾ ε ȣ
    int         ndx_top_button;         //  ư   ̾ ε ȣ
    int         ndx_top_clicked;        //  ư   ̾ ε ȣ
    int         ndx_rht_button;         //  ư   ̾ ε ȣ
    int         ndx_rht_clicked;        //  ư   ̾ ε ȣ
    int         ndx_btm_button;         // Ʒ ư   ̾ ε ȣ
    int         ndx_btm_clicked;        // Ʒ ư   ̾ ε ȣ
    int         ndx;

                                        // layer ü 

    layer = gx_layer_create(  dc_screen,            //   DC
                              50 ,  25,             // Layer Screen  ġ
                              300, 250);            // Layer  

                                        //  ̿Ͽ ̾ ߰

    png = gx_png_open( "fish.png");             ndx_fish        = gx_layer_add( layer, (dc_t *)png,-100, 200, GX_FALSE);
    png = gx_png_open( "chimpanzee.png");       ndx_chimpanzee  = gx_layer_add( layer, (dc_t *)png, 300,  10, GX_FALSE);
    png = gx_png_open( "left.png");             ndx_lft_button  = gx_layer_add( layer, (dc_t *)png,   5,  18, GX_TRUE );
    png = gx_png_open( "left-clicked.png");     ndx_lft_clicked = gx_layer_add( layer, (dc_t *)png,   5,  18, GX_FALSE);
    png = gx_png_open( "top.png");              ndx_top_button  = gx_layer_add( layer, (dc_t *)png,  18,   4, GX_TRUE );
    png = gx_png_open( "top-clicked.png");      ndx_top_clicked = gx_layer_add( layer, (dc_t *)png,  18,   4, GX_FALSE);
    png = gx_png_open( "right.png");            ndx_rht_button  = gx_layer_add( layer, (dc_t *)png, 110,  18, GX_TRUE );
    png = gx_png_open( "right-clicked.png");    ndx_rht_clicked = gx_layer_add( layer, (dc_t *)png, 110,  18, GX_FALSE);
    png = gx_png_open( "bottom.png");           ndx_btm_button  = gx_layer_add( layer, (dc_t *)png,  18, 107, GX_TRUE );
    png = gx_png_open( "bottom-clicked.png");   ndx_btm_clicked = gx_layer_add( layer, (dc_t *)png,  18, 107, GX_FALSE);
    bmp = gx_bmp_open( "bpp-32.bmp");                             gx_layer_add( layer, (dc_t *)bmp,   0,   0, GX_TRUE);
    gx_layer_redraw( layer);                                                    // ̾ ü 
    usleep( 500000);

                                        // ư ϸ鼭 ȭ鿡 , ̴  ߻

    gx_layer_visible( layer, ndx_lft_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_lft_clicked  , GX_TRUE );
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_lft_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_lft_clicked  , GX_FALSE);
    gx_layer_visible( layer, ndx_top_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_top_clicked  , GX_TRUE );
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_top_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_top_clicked  , GX_FALSE);
    gx_layer_visible( layer, ndx_rht_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_rht_clicked  , GX_TRUE );
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_rht_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_rht_clicked  , GX_FALSE);
    gx_layer_visible( layer, ndx_btm_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_btm_clicked  , GX_TRUE );
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_btm_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_btm_clicked  , GX_FALSE);

                                        // ư  ° ص  ,  

    gx_layer_manual( layer, GX_TRUE);                                           // ̾ ȭ ־ ȭ  . gx_layer)redraw() ȣ ־ 

    gx_layer_visible( layer, ndx_lft_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_lft_clicked  , GX_TRUE );
    gx_layer_redraw( layer);
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_lft_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_lft_clicked  , GX_FALSE);
    gx_layer_visible( layer, ndx_top_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_top_clicked  , GX_TRUE );
    gx_layer_redraw( layer);
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_top_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_top_clicked  , GX_FALSE);
    gx_layer_visible( layer, ndx_rht_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_rht_clicked  , GX_TRUE );
    gx_layer_redraw( layer);
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_rht_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_rht_clicked  , GX_FALSE);
    gx_layer_visible( layer, ndx_btm_button   , GX_FALSE);
    gx_layer_visible( layer, ndx_btm_clicked  , GX_TRUE );
    gx_layer_redraw( layer);
    usleep( 500 *1000);                                                         // 500 msec

    gx_layer_visible( layer, ndx_btm_button   , GX_TRUE );
    gx_layer_visible( layer, ndx_btm_clicked  , GX_FALSE);
    gx_layer_redraw( layer);

    gx_layer_manual( layer, GX_FALSE);                                  // ̾ ȭ  ٷ ȭ 

                                        // ħ ⸦ ̵

    gx_layer_visible( layer, ndx_fish        , GX_TRUE );
    gx_layer_visible( layer, ndx_chimpanzee  , GX_TRUE );
    for ( ndx = 0; ndx < 200; ndx++)
    {
        gx_layer_move( layer, ndx_fish       ,  1, -1);
        gx_layer_move( layer, ndx_chimpanzee , -1,  0);
    }
    for ( ndx = 0; ndx < 200; ndx++)
    {
        gx_layer_move( layer, ndx_fish       ,  1, 1);
        gx_layer_move( layer, ndx_chimpanzee , -1, -1);
    }
    for ( ndx = 0; ndx < 200; ndx++)
    {
        gx_layer_move( layer, ndx_fish       , -1, 0);
        gx_layer_move( layer, ndx_chimpanzee ,  1, 1);
    }

    for ( ndx = 0; ndx < 200; ndx++)
    {
        gx_layer_move( layer, ndx_fish       , 0, -1);
        gx_layer_move( layer, ndx_chimpanzee , 0,  1);
    }
    for ( ndx = 0; ndx < 200; ndx++)
    {
        gx_layer_move( layer, ndx_fish       , -1,  0);
        gx_layer_move( layer, ndx_chimpanzee ,  0, -1);
    }
    for ( ndx = 0; ndx < 200; ndx++)
    {
        gx_layer_move( layer, ndx_fish       ,  1,  0);
        gx_layer_move( layer, ndx_chimpanzee ,  0,  1);
    }
    for ( ndx = 0; ndx < 300; ndx++)
    {
        gx_layer_move( layer, ndx_fish       ,  0,  1);
        gx_layer_move( layer, ndx_chimpanzee ,  1,  1);
    }

    gx_layer_move_to( layer, ndx_fish        ,  120,  100);
    gx_layer_move_to( layer, ndx_chimpanzee  ,   80,    0);

    gx_layer_close( layer);
}

void test_mosaic( void)
{
    mosaic_t   *mosaic;
    int         ndx;

    gx_clear( dc_screen, gx_color( 0, 0, 0, 255));

                                        //  ü 

    mosaic = gx_mosaic_create(  (dc_t *)gx_png_open( "fore.png"),               // ҿ µǴ ̹
                                (dc_t *)gx_png_open( "back.png"),               //   µ ̹
                                (dc_t *)gx_png_open( "color_table.png"),        //   ϴ ̹
                                100, 100);          //   DC  x, y ġ

                                        // ̹  ۺ ǥ  

    gx_mosaic_add( mosaic,  0,  0, 30, 91,                                      // ۿ شϴ ̹ left, top, width, height
                            8, 37);                                             // ش   ϴ x, y ǥ.
    gx_mosaic_add( mosaic, 23,  2, 59, 44, 40, 14);                             //  ǥ    ִ.
    gx_mosaic_add( mosaic, 60, 10, 36, 42, 75, 28);
    gx_mosaic_add( mosaic, 22, 37, 55, 47, 46, 62);
    gx_mosaic_add( mosaic, 31, 56, 65, 41, 83, 84);

    for ( ndx = 0; ndx < mosaic->count; ndx++)
    {
        gx_mosaic_draw( dc_screen, mosaic, ndx);
        usleep( 500 *1000);                                                     // 500 msec
    }

    gx_mosaic_close( mosaic);
}

void test_list( void)
{
    image_list_t  *list;                // ̹ Ʈ ü ڵ
    png_t         *png_cell;
    int            ndx;

    if ( !( list = gx_imagelist_create( "sample-list.png", 90, 90)))
        gx_print_error( "gx_imagelist_create()");
    else
    {
        for ( ndx = 0; ndx < list->count; ndx++)
        {
                                        // ̹ Ʈ ε شϴ ̹ 
            png_cell = gx_imagelist_get( list, ndx);
            gx_bitblt( dc_screen, 200, 200,
                        (dc_t *)png_cell, 0, 0, png_cell->width, png_cell->height);
            usleep( 500 *1000);                                                 // 500 msec
        }
        gx_imagelist_close( list);
    }
}

void test_text( void)
{
    if ( gx_set_font( "nbold32.bdf"))
            gx_print_error("nbold32.bdf");
    else
    {
       dc_screen->pen_color = gx_color( 0, 0, 0, 255);
       gx_text_out( dc_screen, 50 , 270, "FALINUX !!"  );
    }
}

void view_png( char *png_name, int coor_x, int coor_y)
{
    png_t   *png;

    png = gx_png_open( png_name);
    if ( NULL == png)
        gx_print_error( png_name);                                              //     
    else
    {
        gx_bitblt( dc_screen, coor_x, coor_y, ( dc_t *)png, 0, 0, png->width, png->height);
        gx_png_close( png);
        usleep( 300 *1000);                                                     // 300 msec
    }
}
void test_png( void)
{
    view_png( "png-08bpp.png", 0,  10);
    view_png( "png-24bpp.png", 0,  80);
    view_png( "png-test.png" , 0, 150);
    view_png( "png-back.png" , 0, 210);
}

void test_jpg( void)
{
    char    *jpg_name = "jpeg-image.jpg";
    jpg_t   *jpg;

    jpg = gx_jpg_open( jpg_name);
    if ( NULL == jpg)
        gx_print_error( jpg_name);                                              //     
    else
    {
        gx_bitblt( dc_screen, 0, 0, ( dc_t *)jpg, 0, 0, jpg->width, jpg->height);
        gx_jpg_close( jpg);
    }
}

void view_bmp( char *bmp_name)
{
    bmp_t   *bmp;

    bmp = gx_bmp_open( bmp_name);
    if ( NULL == bmp)
        gx_print_error( bmp_name);                                              //     
    else
    {
        gx_bitblt( dc_screen, 0, 0, ( dc_t *)bmp, 0, 0, bmp->width, bmp->height);
        gx_bmp_close( bmp);
        usleep( 300 *1000);                                                     // 300 msec
    }
}

void test_bitmap( void)
{
    view_bmp( "bpp-01.bmp");
    view_bmp( "bpp-04.bmp");
    view_bmp( "bpp-08.bmp");
    view_bmp( "bpp-24.bmp");
    view_bmp( "bpp-32.bmp");
}

void test_ellipse( void)
{
    int      coor_x, coor_y;
    int      width,  height;
    int      ndx;

    gx_clear( dc_screen, gx_color( 0, 0, 0, 255));
    for ( ndx = 0; ndx < 50; ndx++)
    {
        coor_x         = rand() % VIEW_WIDTH;
        coor_y         = rand() % VIEW_HEIGHT;
        width          = rand() % HALF_WIDTH;
        height         = rand() % HALF_HEIGHT;

        switch ( rand() % 3)
        {
        case 0   :
                 dc_screen->pen_color     = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 dc_screen->brush_color   = gx_color( 0, 0, 0, 0);
                 break;
        case 1   :
                 dc_screen->pen_color     = gx_color( 0, 0, 0, 0);
                 dc_screen->brush_color   = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 break;
        default  :
                 dc_screen->pen_color     = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 dc_screen->brush_color   = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 break;
        }
        gx_ellipse( dc_screen, coor_x, coor_y, width, height);
        usleep( 50 *1000);
    }
}

void  test_circle( void)
{
    int      coor_x, coor_y;
    int      radius;
    int      ndx;

    gx_clear( dc_screen, gx_color( 0, 0, 0, 255));
    for ( ndx = 0; ndx < 50; ndx++)
    {
        coor_x         = rand() % VIEW_WIDTH;
        coor_y         = rand() % VIEW_HEIGHT;
        radius         = rand() % HALF_WIDTH;

        switch ( rand() % 3)
        {
        case 0   :
                 dc_screen->pen_color     = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 dc_screen->brush_color   = gx_color( 0, 0, 0, 0);
                 break;
        case 1   :
                 dc_screen->pen_color     = gx_color( 0, 0, 0, 0);
                 dc_screen->brush_color   = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 break;
        default  :
                 dc_screen->pen_color     = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 dc_screen->brush_color   = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 break;
        }
        gx_circle( dc_screen, coor_x, coor_y, radius);
        usleep( 50 *1000);
    }
}

void  test_rectangle( void)
{
    int     x1, y1, x2, y2;
    int     ndx;

    gx_clear( dc_screen, gx_color( 0, 0, 0, 255));
    dc_screen->brush_color   = gx_color( 0, 0, 0, 0);

    for ( ndx= 0; ndx < 50; ndx++)
    {
        x1  = rand() % VIEW_WIDTH;
        y1  = rand() % VIEW_HEIGHT;
        x2  = rand() % VIEW_WIDTH;
        y2  = rand() % VIEW_HEIGHT;

        switch ( rand() % 3)
        {
        case 0   :
                 dc_screen->pen_color     = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 dc_screen->brush_color   = gx_color( 0, 0, 0, 0);
                 break;
        case 1   :
                 dc_screen->pen_color     = gx_color( 0, 0, 0, 0);
                 dc_screen->brush_color   = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 break;
        default  :
                 dc_screen->pen_color     = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 dc_screen->brush_color   = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
                 break;
        }
        gx_rectangle( dc_screen, x1, y1, x2, y2);
        usleep( 50 *1000);                                                      // 50 msec
    }
}

void test_get_set_pixel( void)
{
    #define LINE_MAX        100
    color_t	color;
    int     coor_x;
    int     coor_y;
    int     ndx;

    gx_clear( dc_screen, gx_color( 0, 0, 0, 255));
    dc_screen->pen_color  = gx_color( 255, 255, 255, 255);

    for( ndx = 0; ndx < LINE_MAX; ndx +=10)
    {
        gx_line( dc_screen, 0  , 0  , ndx     , LINE_MAX);
        gx_line( dc_screen, 0  , 0  , LINE_MAX, ndx     );
        gx_line( dc_screen, ndx, 0  , ndx     , LINE_MAX);
        gx_line( dc_screen, 0  , ndx, LINE_MAX, ndx     );
    }

    gx_move_to( dc_screen, rand() % HALF_WIDTH, rand() % VIEW_WIDTH);
    for ( ndx= 0; ndx < 100; ndx++)
    {
       dc_screen->pen_color  = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
       gx_line_to( dc_screen, rand() % HALF_WIDTH, rand() % VIEW_HEIGHT);
    }
    for ( coor_y = 0; coor_y < VIEW_HEIGHT; coor_y++)
        for ( coor_x = 0; coor_x < HALF_WIDTH; coor_x++)
        {
            gx_get_pixel( dc_screen, coor_x           , coor_y, &color);
            gx_set_pixel( dc_screen, coor_x+HALF_WIDTH, coor_y,  color);
        }

}

void test_line( void)
{
    #define LINE_MAX        100
    int     ndx;

    gx_clear( dc_screen, gx_color( 0, 0, 0, 255));
    dc_screen->pen_color  = gx_color( 255, 255, 255, 255);

    for( ndx = 0; ndx < LINE_MAX; ndx +=10)
    {
        gx_line( dc_screen, 0  , 0  , ndx     , LINE_MAX);
        gx_line( dc_screen, 0  , 0  , LINE_MAX, ndx     );
        gx_line( dc_screen, ndx, 0  , ndx     , LINE_MAX);
        gx_line( dc_screen, 0  , ndx, LINE_MAX, ndx     );
    }

    gx_move_to( dc_screen, rand() % VIEW_WIDTH, rand() % VIEW_HEIGHT);
    for ( ndx= 0; ndx < 100; ndx++)
    {
       dc_screen->pen_color  = gx_color( rand() %128 +128, rand() %128 +128, rand() %128 +128, 255);
       gx_line_to( dc_screen, rand() % VIEW_WIDTH, rand() % VIEW_HEIGHT);
    }
}

int   main( void)
{
    if  ( gx_init( "/dev/fb"))                      // gxLib ʱȭ
        gx_print_error( "ο ȣ");           //     
    else
    {
        if ( !( dc_screen = gx_get_screen_dc()))    // ȭ   ũ DC 
            gx_print_error( "ο ȣ");       //     
        else
        {
            
            
            
            srand( (unsigned)time(NULL)+(unsigned)getpid());

            //test_line();             getchar();               //  ߱ ׽Ʈ
            //test_get_set_pixel();    getchar();               //   б   ׽Ʈ
            //test_rectangle();        getchar();
            //test_circle();           getchar();
            //test_ellipse();          getchar();
            //test_bitmap();           getchar();
            //test_jpg();              getchar();
            //test_png();              getchar();
            //test_text();             getchar();
            //test_list();             getchar();
            //test_mosaic();           getchar();               // ũ ׽Ʈ
            //test_layer();                                     // ̾ ׽Ʈ
            //test_file)open();
            //test_file_open();
            test_bitblt_mask();

            gx_release_dc( dc_screen);
        }
        gx_close();
    }
    return   0;
}                                                                           
